unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Registry;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
  private
    { Private declarations }
    R: TRegistry;
    sData: TStringList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  R := TRegistry.Create;
  sData := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  R.Free;
  sData.Free;
end;

procedure TForm1.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var
  kName: String;
  I: Integer;
  S: TStringList;
  nNode: TTreeNode;
begin
  if (Node.Count = 1) and (Node.Item[0].Text = '') then
  begin
    if Node.Data <> nil then
      kName := sData[Integer(Node.Data)]
    else
      kName := '';
    Node.DeleteChildren;
    R.OpenKeyReadOnly(kName);
    S := TStringList.Create;
    R.GetKeyNames(S);
    for I := 0 to S.Count - 1 do
    begin
      sData.Add(kName + '\' + S[I]);
      nNode := TreeView1.Items.AddChild(Node, S[I]);
      nNode.Data := Pointer(sData.Count - 1);
      TreeView1.Items.AddChild(nNode, '');
    end;
    S.Free;
  end;
end;

end.
